/****************************************************************************
 * <Novell-copyright>
 * Copyright (c) 2001 Novell, Inc. All Rights Reserved.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 2 of the GNU General Public License
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact Novell, Inc.
 * 
 * To contact Novell about this file by physical or electronic mail, you 
 * may find current contact information at www.novell.com.
 * </Novell-copyright>
 ****************************************************************************/
#include <config.h>

#include <xpl.h>
#include <connio.h>
#include <hulautil.h>
#include <msgapi.h>
#include <mdb.h>
#include <management.h>

#include "dmcp.h"

void 
DMCSignalHandler(int sigtype)
{
    switch(sigtype) {
        case SIGHUP: {
            if (DMC.state < DMC_UNLOADING) {
                DMC.state = DMC_UNLOADING;
            }

            break;
        }

        case SIGTERM: {
            if (DMC.state == DMC_STOPPING) {
                XplUnloadApp(getpid());
            } else if (DMC.state < DMC_STOPPING) {
                DMC.state = DMC_STOPPING;
            }

            break;
        }

        default: {
            break;
        }
    }

    return;
}

BOOL 
DMCAgentPrep(DMCAgent *Agent)
{
	return(TRUE);
}

BOOL 
DMCStartAgent(DMCAgent *Agent)
{
	return(TRUE);
}

void 
DMCAgentRelease(DMCAgent *Agent)
{
}

void
DMCKillAgents(void)
{
}

