using System;
using System.IO;
using Hula.Store;
using Hula.Util;
using Lucene.Net.Documents;

namespace Hula.Dav {
public class StreamFormatter : ResultFormatter {
    private static Filter nullFilter = new Hula.Util.Filter();
    private string streamName;
    private Filter filter;


    public StreamFormatter(string streamName,
			   Filter filter) {
	this.streamName = streamName;
	this.filter = filter;
    }

    public StreamFormatter(string streamName) {
	Console.WriteLine("new stream formatter");

	this.streamName = streamName;
	this.filter = nullFilter;
    }

    public override void Format(TextWriter writer, IStore store, string status) {
	if (store != null) {
	    writer.WriteLine("<{0}/>", streamName);
	}
    }

    public override void Format(TextWriter writer, 
				IStore store, 
				Document doc, 
				string status) {
	Console.WriteLine("adding results?");
	if (doc != null 
	    && (doc.GetField("hula.mime-type").StringValue() != "application/x-directory")) {
	    writer.WriteLine("<{0}>", streamName);
	    using (TextReader reader = store.Get(doc.GetField("guid").StringValue())) {
		filter.Run(reader, writer);
	    }
	    writer.WriteLine("</{0}>", streamName);	    
	}
    }
}
}
