using System.Collections;
using System.IO;
using Lucene.Net.Index;
using Lucene.Net.Documents;
using Hula.Store;

namespace Hula.Indexing {

//<summary>
// Default filter for mime types we don't understand.
//</summary>
public class GenericIndexer : Indexer {
    public GenericIndexer() : base(){
    }

    public override void IndexDocument(LuceneIndex idx,
				       IStore store, 
				       string guid) {
	TextReader reader;
	IDictionary properties;

	GetDocument(store, guid, out reader, out properties);
        using (reader) {
            Document doc = new Document();
            AddProperties(doc, properties);
            AddStandardFields(doc, store, guid, properties);
            doc.Add(Field.Text("everything", reader));
            idx.Writer.AddDocument(doc);
        }
    }
} 
}
