using Lucene.Net.Analysis;
using Lucene.Net.Analysis.Standard;

namespace Hula.Indexing {

internal class KeywordTokenizer : CharTokenizer {
    public KeywordTokenizer(System.IO.TextReader reader) : base(reader) { }
    
    protected override bool IsTokenChar(char c) { return true; }
}

internal sealed class KeywordAnalyzer : Analyzer {
    public override TokenStream TokenStream(System.String fieldName, System.IO.TextReader reader) {
	return new KeywordTokenizer(reader);
    }
}

public class HulaAnalyzer : PerFieldAnalyzerWrapper {
    public HulaAnalyzer() : base (new StandardAnalyzer()) {
        // FIXME: there's no keyword analyzer? Well
        WhitespaceAnalyzer keyword = new WhitespaceAnalyzer();

        AddAnalyzer("hula.folder", keyword);
        AddAnalyzer("hula.etag", keyword);
        AddAnalyzer("hula.mime-type", keyword);
        AddAnalyzer("hula.start-time", keyword);
        AddAnalyzer("hula.end-time", keyword);
        AddAnalyzer("ical.type", keyword);
        AddAnalyzer("ical.summary", keyword);
        AddAnalyzer("hula.davhref", keyword);
        AddAnalyzer("hula.davfilename", keyword);
    }
}
}
