using System;
using Hula.Mdb;

public class MdbTest {
	public static void Main() {
		/* have to use null, null for mdb-file
		string username = "\\Tree\\Context\\admin";
		string password = "hula";
		*/
		
		/* directory credentials */
		string username = null;
		string password = null;
		
		/* for testing user creation */
		string testDN = "\\Tree\\Context\\jsixpack";
		string testFirstname = "Joe";
		string testLastname = "Sixpack";
		string testPassword = "test";
		string testFullname = testFirstname + " " + testLastname;
		
		using (MemMgr mgr = new MemMgr()) {
			using (Mdb mdb = new Mdb(username, password)) {
				if (!mdb.IsInitialized) {
					Console.WriteLine("MDB library failed to initialize.");
					return;
				}
			
				if (!mdb.IsAuthenticated) {
					Console.WriteLine("Failed to authenticate.");
				}
			
				/* display MDB info */
				Console.WriteLine();
				Console.Write(mdb);
				Console.WriteLine();
			
				if (mdb.ObjectExists(testDN)) {
					Console.WriteLine("Object already exists.");
				
					using (MdbObject obj = mdb.GetObject(testDN)) {
						if (obj == null) {
							Console.WriteLine("Couldn't get object.");
							return;
						}
					
						if (!mdb.DeleteObject(obj)) {
							Console.WriteLine("Couldn't delete object '" + obj.Dn + "'.");
							return;
						}
						Console.WriteLine("Object has been deleted.");
					}
				}
			
				using (MdbObject uobj = mdb.CreateObject(testDN, MdbObject.C_USER)) {
					if (uobj == null) {
						Console.WriteLine("Failed to create new object.");
						return;
					}

					if (!uobj.AddAttribute(MdbObject.A_SURNAME, testLastname) ||
						!uobj.AddAttribute(MdbObject.A_GIVEN_NAME, testFirstname) ||
						!uobj.AddAttribute(MdbObject.A_FULL_NAME, testFullname)) {
					
						Console.WriteLine("Failed to add attribute(s).");
						return;
					}
				
					Console.WriteLine("New user created successfully.");
				
					uobj.SetAttribute(MdbObject.A_GIVEN_NAME, new string[2]{"Joseph", "Joey"});
				
					Console.WriteLine();
					Console.Write(uobj);

						string[] given = uobj.GetAttributeEx(MdbObject.A_GIVEN_NAME);
						for (int i=0; i < given.GetLength(0); i++) {
							Console.Write(MdbObject.A_GIVEN_NAME + ": " + given[i]);
						}					
						
					Console.WriteLine(MdbObject.A_SURNAME + ": " + uobj.GetAttribute(MdbObject.A_SURNAME)[0]);
					Console.WriteLine(MdbObject.A_FULL_NAME + ": " + uobj.GetAttribute(MdbObject.A_FULL_NAME)[0]);
					Console.WriteLine();
				
					if (!uobj.ChangePassword(null, testPassword)) {
						Console.WriteLine("Couldn't change password.");
						return;
					}
				
					Console.WriteLine("Password changed successfully.");

					Console.WriteLine("");Console.WriteLine("");

					/* read tests */
					Console.WriteLine("host tree: "+mdb.HostTree);

					Console.WriteLine("\\"+mdb.HostTree);
					String[] a = mdb.getObjectList( "\\"+ mdb.HostTree );
					for (int b=0; b < a.GetLength(0); b++) {
						Console.WriteLine(" -"+a[b]);
					}
					Console.WriteLine("");

					String[] x = mdb.getObjectListEx( "\\"+ mdb.HostTree );
					for (int i=0; i < x.GetLength(0); i++){
						Console.WriteLine("  -"+x[i]);
						String[] y = mdb.getObjectListEx("\\"+mdb.HostTree+"\\"+x[i]);
						for (int j=0; j < y.GetLength(0); j++) {
							Console.WriteLine("    -"+y[j]);

							String[] z = mdb.getObjectListEx("\\"+mdb.HostTree+"\\"+x[i]+"\\"+y[j]);
							for (int k=0; k < z.GetLength(0); k++) {
								Console.WriteLine("      -"+z[k]);
							}
						}
					}
				}
			}
		}
	}
}
