/****************************************************************************
 *
 * Copyright (c) 2005 Novell, Inc.
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, contact Novell, Inc.
 *
 * To contact Novell about this file by physical or electronic mail,
 * you may find current contact information at www.novell.com
 *
 ****************************************************************************/

using System;
using System.Collections;

using log4net;

namespace Hula.Nmap
{
public class UserCommands : NmapCommands
{
    public UserCommands(NmapConnection nconn) : base(nconn)
    {
    }

    public IList SHOW(string pattern)
    {
        nconn.WriteRequest("SHOW {0}", pattern);
        NmapResponse response = nconn.ReadLongReply ();
        return new ArrayList(response.data.Split('\n'));
    }

    public void MBOX(string mbox)
    {
        nconn.WriteRequest("MBOX {0}", mbox);
        nconn.ReadFullReply ();
    }
}
}
