<?
function quotearray($ar) {
	return "\"".$ar."\"";
}

$localattrs = array();
$localclass = array();
//DefineAttribute Attribute=Novonyx:Action        ASN1=(null)     Type=83 SingleValue=1   ImmediateSync=1 Public=0
function DefineAttribute($ar) {
    global $localattrs;
	global $ofile;

	//get the attribute name
	$attr = explode('=', $ar[1]);
    $localattrs[$attr[1]] = 1;

    $attr = str_replace(':', '', $attr);
    $attr = str_replace(' ', '', $attr);

	fwrite($ofile, sprintf("\"%s\" ATTRIBUTE ::=\n{\n", $attr[1]));
	fwrite($ofile, "\tOperation\tADD,\n");

	//get the type
	$type = explode('=', $ar[3]);
	if ($type[1] == 83 || $type[1] == 66 || $type[1] == 79) {
		fwrite($ofile, "\tSyntaxID\tSYN_CI_STRING");
	} else if ($type[1] == 68) {
		fwrite($ofile, "\tSyntaxID\tSYN_DIST_NAME");
	} else {
		printf("The attribute type is unknown, continuation is not possible.\n");
        printf("  The attribute information passed in was: ".implode("\t", $ar));
		exit;
	}

	//now set the flags
	$singlevalue = explode('=', $ar[4]);
	$immediatesync = explode('=', $ar[5]);
	$publicread = explode('=', $ar[6]);

	$flags = array();
	if ($immediatesync[1]==1)
		$flags[] = "DS_SYNC_IMMEDIATE";

	if ($publicread[1]==1)
		$flags[] = "DS_PUBLIC_READ";

	if ($singlevalue[1]==1)
		$flags[] = "DS_SINGLE_VALUED_ATTR";

	if (count($flags) > 0) {
		fwrite($ofile, sprintf(",\n\tFlags\t{%s}\n", implode(",", $flags)));
	}

	fwrite($ofile, "}\n");
}

//DefineClass     Class=Novonyx:Services  ASN1=(null)     Container=1     super=Top-      containment=Top-Organization-Organizational Unit-       naming=O-       mandatory=O-    optional=
$classes = array();
function DefineClass($ar) {
	global $classes;
    global $localattrs;
    global $localclass;
	$current = array();

	$name=explode('=', $ar[1]);
    $localclass[$name[1]] = 1;
    $name[1] = str_replace(':', '', $name[1]);
    $name[1] = str_replace(' ', '', $name[1]);

	//split the super classes
	$ar2=explode('=', $ar[4]);
	$t=substr($ar2[1], 0, -1);
	$current["SubClassOf"]=(strlen($t)>0) ? explode('-', $t) : array();

	//container
	$container=explode('=', $ar[3]);
	$current["Flags"][] = "DS_EFFECTIVE_CLASS";
	//$current["Flags"][] = "DS_AUXILIARY_CLASS";
	if ($container[1]==1)
		$current["Flags"][] = "DS_CONTAINER_CLASS";

	//split the containment classes
	$ar2=explode('=', $ar[5]);
	$t = substr($ar2[1], 0, -1);
	$current["ContainedBy"]=(strlen($t)>0) ? explode('-', $t) : array();

	//split the naming attribute
	$ar2=explode('=', $ar[6]);
	$t = substr($ar2[1], 0, -1);
	$current["NamedBy"]=(strlen($t)>0)? explode('-', $t) : array();

	//split the mandatory classes
	$ar2=explode('=', $ar[7]);
	$t = substr($ar2[1], 0, -1);
	$current["MustContain"]=(strlen($t)>0)? explode('-', $t) : array();

	//make sure that the naming attribute is in the mandatory list
	if (count($current["NamedBy"]) > 0) {
		foreach($current["NamedBy"] as $value) {
			$current["MustContain"][] = $value;
		}
	}

	//split the optional
	$ar2=explode('=', $ar[8]);
	$t = substr($ar2[1], 0, -1);
	$current["MayContain"]=(strlen($t)>0)? explode('-', $t) : array();

	$classes[$name[1]] = $current;
}

// AddAttribute    Attribute=Novonyx:Alias Class=Novonyx:Services
function AddAttribute($ar) {
	global $classes;
    global $localclass;

	//find the classname
	$class = explode('=', $ar[2]);
    if ($localclass[$class[1]] == 1) {
        $class[1] = str_replace(':', '', $class[1]);
        $class[1] = str_replace(' ', '', $class[1]);
    }
	$attribute = explode('=', $ar[1]);
	$classes[$class[1]]["MayContain"][] = $attribute[1];
}

//parse the command line and if any option is not there, then error out with a help screen
function ParseCommandLine($argv) {
	$cnt = count($argv);
	for($x=1;$x<$cnt;$x++) {
		$str = explode('=', $argv[$x]);
		if (strcasecmp($str[0], '-h') == 0) {
			PrintHelp();
		} else if (strcasecmp($str[0], '-i') == 0) {
			global $infile;
			$infile = $str[1];
			continue;			
		} else if (strcasecmp($str[0], '-o') == 0) {
			global $outfile;
			$outfile = $str[1];
			continue;
		} else if (strcasecmp($str[0], '-d') == 0) {
			global $default;
			$default = $str[1];
			continue;
		} else {
			PrintHelp();
		}
	}
}

function PrintHelp() {
	echo "Usage: \n";
	echo "  php -q edir.php -i=infilename -o=outfilename -d=defaultnaming\n";
	echo "    -i:	the name of the file that contains the output from mdb.conf\n";
	echo "    -o:	the name of the file you would like to drop the .sch definitions into\n";
	echo "    -d:   should a class not have a naming attribute, use this as the default\n";	
	exit;
}

ParseCommandLine($argv);
if (!isset($infile) || !isset($outfile)) {
	PrintHelp();
	exit;
}

if (!isset($default)) {
    echo "Warning:  No default namming attribute has been defined.  This could cause\n";
    echo "  the schema file that is generated to be incorrect.\n";
}

$ifile = fopen($infile, "r");
$ofile = fopen($outfile, "w");

if (!$ifile || !$ofile) {
	echo "there was an error opening either of the files\n";
	exit;
}

//start the file
fwrite($ofile, "MDBSchemaExtentions DEFINITIONS ::=\nBEGIN\n");


while(!feof($ifile)) {
	$line = trim(fgets($ifile));
	$ar = explode("	", $line);
	if ($ar[0] == "DefineAttribute") {
		DefineAttribute($ar);
	} else if ($ar[0] == "DefineClass") {
		DefineClass($ar);
	} else if ($ar[0] == "AddAttribute") {
		AddAttribute($ar);
	}
}

/*
"Novonyx:Services" OBJECT-CLASS ::=
{
        Operation       ADD,
        SubClassOf      {"TOP"},
        Flags           {DS_EFFECTIVE_CLASS},
        ContainedBy     {"Top", "Organization", "Organizational Unit"},
        NamedBy         {"O"},
        MustContain     {"O"},
        MayContain      {"Novonyx:Alias", "NIMS:ConfigVersion", "Novonyx:Accounting Enabled",
                                        "NIMS:Default Charset", "NIMS:ACL", "NIMS:FeatureSet", "NIMS:WebmailPluginOrder",
                                        "NIMS:PKeyFile", "NIMS:CAFile", "NetMail:AvailableShares", "NetMail:AvailableProxies",
                                        "Private Key", "Public Key", "Login Intruder Address", "Login Intruder Attempts"}
}
*/
//since i'm here i need to dump the class definitions now
foreach($classes as $classname => $classarray) {
	fwrite($ofile, sprintf("\"%s\" OBJECT-CLASS ::=\n{\n", $classname));
	//if there is no flags then this is a MODIFY operation not an add
	if (isset($classarray["Flags"])) {
		fwrite($ofile, "\tOperation\tADD");

        for($x=0;$x<count($classarray["SubClassOf"]);$x++) {
            if ($localclass[$classarray["SubClassOf"][$x]]==1) {
                $classarray["SubClassOf"][$x] = str_replace(':', '', $classarray["SubClassOf"][$x]);
                $classarray["SubClassOf"][$x] = str_replace(' ', '', $classarray["SubClassOf"][$x]);
            }
        }
		$ar = array_map("quotearray", $classarray["SubClassOf"]);
		if (count($ar) > 0) {
			fwrite($ofile, sprintf(",\n\tSubClassOf\t{%s}", implode(",", $ar)));
		}

		if (isset($classarray["Flags"])) { 
			fwrite($ofile, sprintf(",\n\tFlags\t{%s}", implode(",", $classarray["Flags"])));
		}

        for($x=0;$x<count($classarray["ContainedBy"]);$x++) {
            if ($localclass[$classarray["ContainedBy"][$x]]==1) {
                $classarray["ContainedBy"][$x] = str_replace(':', '', $classarray["ContainedBy"][$x]);
                $classarray["ContainedBy"][$x] = str_replace(' ', '', $classarray["ContainedBy"][$x]);
            }
        }
		$ar = array_map("quotearray", $classarray["ContainedBy"]);
		if (count($ar)>0) {
			fwrite($ofile, sprintf(",\n\tContainedBy\t{%s}", implode(",", $ar)));
		}

        for($x=0;$x<count($classarray["NamedBy"]);$x++) {
            if ($localattrs[$classarray["NamedBy"][$x]]==1) {
                $classarray["NamedBy"][$x] = str_replace(':', '', $classarray["NamedBy"][$x]);
                $classarray["NamedBy"][$x] = str_replace(' ', '', $classarray["NamedBy"][$x]);
            }
        }
		$ar = array_map("quotearray", $classarray["NamedBy"]);
		if (count($ar)>0) {
			fwrite($ofile, sprintf(",\n\tNamedBy\t{%s}", implode(",", $ar)));
		} else {
            //if ar is null, then we need to make sure to add the default to this class in both
            // naming and mustcontain
            fwrite($ofile, sprintf(",\n\tNamedBy\t{\"%s\"}", $default));
            $classarray["MustContain"][] = $default;
        }

        for($x=0;$x<count($classarray["MustContain"]);$x++) {
            if ($localattrs[$classarray["MustContain"][$x]]==1) {
                $classarray["MustContain"][$x] = str_replace(':', '', $classarray["MustContain"][$x]);
                $classarray["MustContain"][$x] = str_replace(' ', '', $classarray["MustContain"][$x]);
            }
        }
		$ar = array_map("quotearray", $classarray["MustContain"]);
		if (count($ar)>0) {
			fwrite($ofile, sprintf(",\n\tMustContain\t{%s}", implode(",", $ar)));
		}
	} else {
		fwrite($ofile, "\tOperation\tMODIFY");
	}

    for($x=0;$x<count($classarray["MayContain"]);$x++) {
        if ($localattrs[$classarray["MayContain"][$x]]==1) {
            $classarray["MayContain"][$x] = str_replace(':', '', $classarray["MayContain"][$x]);
            $classarray["MayContain"][$x] = str_replace(' ', '', $classarray["MayContain"][$x]);
        }
    }
	$ar = array_map("quotearray", $classarray["MayContain"]);
	if (count($ar)>0) {
		fwrite($ofile, sprintf(",\n\tMayContain\t{%s}\n", implode(",", $ar)));
	}
	fwrite($ofile, "}\n");
}

fwrite($ofile, "END");
?>
